CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  'Insert other constants here

OBJ
  KB: "Keyboard"
  VideoDisplay: "TV_Text-WP"

VAR
  byte linelength[100]
  byte character[4000]
  byte xvalue
  byte yvalue
  byte linenum
  byte charvalue
  word endvalue
  word endvalue2

PUB Start
  KB.Startx(26, 27, %0_000_000, %01_01000)
  VideoDisplay.Start(12)
  WaitCnt(50_000_000 + cnt)
  KeyboardPlayback

PRI KeyboardPlayback | InputKey, i, j, k, FirstDone, ResetScreen, displaynum, pageoney
  charvalue := 0
  ResetScreen := 0
  FirstDone := 0
  ByteFill(@character, $BC, 4000)
  Repeat
    If KB.Present
      VideoDisplay.setxy(0, 12)
      VideoDisplay.str(string("Welcome to Propeller Word Processor"))
      xvalue := 0
      yvalue := 0
      VideoDisplay.setxy(xvalue, yvalue)
      VideoDisplay.out($0E)
      linenum := 0
      'character[0] := $BC
      Repeat
        charvalue += 1
        InputKey := KB.GetKey                           'Get current key being pressed from keyboard routine
        If InputKey == $C8 AND xvalue <> 0              'If pressing the delete key and not at the start of a line
          xvalue -= 1                                   'Move back 1 character
          linelength[linenum] -= 1
          VideoDisplay.out(" ")                         'Write blank character over cursor
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out($0E)                         'Write cursor character over previous character
          charvalue -= 2
        ElseIf InputKey == $C8 AND xvalue == 0 AND yvalue <> 0                'If pressing the delete key at the start of a line
          yvalue -= 1                                   'Move up one line
          linenum -= 1
          xvalue := linelength[linenum]                 'Get x-value of last character on previous line
          VideoDisplay.out(" ")
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out($0E)
          charvalue -= 2
        ElseIf InputKey == 13                           'If Return key pressed
          VideoDisplay.out(" ")
          yvalue += 1                                   'Go down one line
          linenum += 1
          xvalue := 0                                   'Set x-value to zero
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out($0E)                         'Draw cursor on next line
          character[charvalue] := $FF
        ElseIf InputKey == $C8                        'Prevent bug with delete key at 0,0
        ElseIf xvalue == 39                             'If at the end of line
          VideoDisplay.out(" ")
          yvalue += 1                                   'Go down one line
          xvalue := 0                                   'Set x-value to zero
          linenum += 1
          VideoDisplay.setxy(xvalue, yvalue)            'Set x and y values
          VideoDisplay.out(InputKey)                    'Display character
          xvalue += 1                                   'Increment x-value
          linelength[linenum] += 1
          character[charvalue] := $FF
          charvalue +=1
          character[charvalue] := InputKey
        ElseIf InputKey == $C6                          'When Page Up key is pressed
          xvalue := 0
          linenum := 0
          yvalue := 0
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out(0)                           'Clear Screen
          j := charvalue - 1
          k := 1
          VideoDisplay.out(character[0])
          Repeat i from k to j                          'Output all previous characters
            VideoDisplay.setxy(xvalue, yvalue)
            If character[i] == $FF
              xvalue := 0
              yvalue += 1
              linenum += 1
            ElseIf character[i] == $FE                  'If you find the 'end value' character, stop printing characters
              endvalue := i                             'Set the variable 'endvalue' to the index of the character array at which the end value character is found
              Quit
            Else
              VideoDisplay.out(character[i])
              xvalue += 1
          linenum -= 1
          VideoDisplay.setxy(0, 12)
          VideoDisplay.str(string("PAGE 1. TO RETURN PRESS PAGE DOWN"))  'Notify user of page change
          xvalue := linelength[pageoney]
          yvalue := pageoney
          VideoDisplay.setxy(xvalue, yvalue)            'Set cursor at end of page
          VideoDisplay.out($0E)
          endvalue2 := charvalue                        'Preserve character array index of page 2
          charvalue := endvalue - 1                     'Set index of character array to the place before the end value character is found
        ElseIf linenum == 12 OR InputKey == $C7         'If end of page 1 reached or Page Down pressed
          If InputKey == $C7 AND FirstDone == 0         'If Page Down pressed without reaching end of page 1, do nothing
          ElseIf linenum == 12 AND FirstDone == 0       'If end of page one reached for the first time:
            FirstDone := 1                              'Set FirstDone variable to 1
            linenum := 13
            character[charvalue] := $FE                 'Record the 'end value' character at this location
            VideoDisplay.out(0)                         'Clear the screen
            VideoDisplay.setxy(1, 12)
            VideoDisplay.str(string("PAGE 2. TO RETURN PRESS PAGE UP")) 'Notify user of page change
            pageoney := 11
            ResetScreen := 1
          ElseIf InputKey == $C7 AND FirstDone == 1     'If Page Down pressed for the second time, third time, etc.
            charvalue := endvalue2                      'Set the character array index to the 'end value' of page 2, recorded in the "if" loop for pressing Page Up
            VideoDisplay.out(0)                         'Clear the screen
            VideoDisplay.setxy(1, 12)
            VideoDisplay.str(string("PAGE 2. TO RETURN PRESS PAGE UP")) 'Notify user of page change
            pageoney := yvalue
            xvalue := 0
            yvalue := 0
            VideoDisplay.setxy(xvalue, yvalue)          'Place cursor at 0,0
            k := endvalue2
            linenum := 13
            Repeat i from endvalue to k         'From the end value of page 1 to the end value of page 2, print characters
              VideoDisplay.setxy(xvalue, yvalue)
              If character[i] == $FF
                xvalue := 0
                yvalue += 1
                linenum += 1
              ElseIf character[i] == $BC
              Else
                VideoDisplay.out(character[i])
                xvalue += 1
            charvalue -= 1
        ElseIf ResetScreen == 1
          xvalue := 0
          yvalue := 0
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out($0E)
          ResetScreen := 0
        Else                                            'If no special conditions:
          VideoDisplay.setxy(xvalue, yvalue)            'Set x and y values
          character[charvalue] := InputKey
          VideoDisplay.out(character[charvalue])                    'Display character
          xvalue += 1                                   'Increment x-value
          VideoDisplay.setxy(xvalue, yvalue)
          VideoDisplay.out($0E)
          linelength[linenum] += 1
        VideoDisplay.setxy(35, 12)                      'This code displays x and y values in lower-right corner
        If linenum < 12 OR linenum == 12
          VideoDisplay.dec(linenum)
        ElseIf linenum > 12
          displaynum := linenum - 1
          VideoDisplay.dec(displaynum)
        VideoDisplay.out(",")
        VideoDisplay.dec(linelength[linenum])
        VideoDisplay.out(" ")
        VideoDisplay.setxy(xvalue, yvalue)
    Else
      VideoDisplay.str(string("Please Plug In Keyboard"))
      VideoDisplay.out(13)
